' @copyright(disclaimer) 
' Licensed Materials - Property of IBM
' IBM  Enterprise Information Portal for Multiplatforms V8.1  (program number 5724-B43)
' (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.
' 
' US Government Users Restricted Rights
' Use, duplication or disclosure restricted by GSA ADP Schedule
' Contract with IBM Corp.
' 
' DISCLAIMER OF WARRANTIES :
' 
' Permission is granted to copy and modify this Sample code, and to
' distribute modified versions provided that both the copyright
' notice,- and this permission notice and warranty disclaimer appear in all copies and 
' modified versions. 
' 
' THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. 
' IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, 
' IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE IMPLIED 
' WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT WILL 
' IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT OF THE USE OF OR 
' INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE, OR COMBINATION OF THE 
' SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS LICENSORS AND 
' SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR FOR DIRECT, INDIRECT, 
' SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF 
' THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS HAVE BEEN ADVISED 
' OF THE POSSIBILITY OF SUCH DAMAGES.
'
' @endCopyright

VERSION 5.00
Begin VB.Form TxdoCRUDDL 
   Caption         =   "TxdoCRUDDL"
   ClientHeight    =   10260
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6465
   LinkTopic       =   "TxdoCRUDDL"
   ScaleHeight     =   10260
   ScaleWidth      =   6465
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Update 
      Caption         =   "Update"
      Height          =   495
      Left            =   4560
      TabIndex        =   6
      Top             =   9000
      Width           =   1335
   End
   Begin VB.CommandButton Delete 
      Caption         =   "Delete"
      Height          =   495
      Left            =   3000
      TabIndex        =   5
      Top             =   9000
      Width           =   1215
   End
   Begin VB.CommandButton Retrieve 
      Caption         =   "Retrieve"
      Height          =   495
      Left            =   1560
      TabIndex        =   4
      Top             =   9000
      Width           =   1215
   End
   Begin VB.CommandButton Add 
      Caption         =   "Add"
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   9000
      Width           =   1215
   End
   Begin VB.CommandButton Disconnect 
      Caption         =   "Disconnect"
      Height          =   495
      Left            =   2040
      TabIndex        =   2
      Top             =   8160
      Width           =   1215
   End
   Begin VB.CommandButton Connect 
      Caption         =   "Connect"
      Height          =   495
      Left            =   240
      TabIndex        =   1
      Top             =   8160
      Width           =   1455
   End
   Begin VB.TextBox Results 
      Height          =   7455
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   240
      Width           =   6015
   End
End
Attribute VB_Name = "TxdoCRUDDL"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Dim dsDL As DXDatastoreDL
Dim xdo As DXBlobDL
Dim pid As DXPidXDODL
Dim itemId As String
Dim fileName1 As String
Dim fileName2 As String
Dim partId As Integer
Dim repType As String

Private Sub cout(str As String)
    Results.Text = Results.Text & Chr$(13) & Chr$(10) & str
End Sub

Private Sub Connect_Click()
    
    cout "The following itemId and partId will be used:"
    cout "(Please change the itemId to an existing one of your system, "
    cout " and change the partId to the one you pick, "
    cout " or use 0 to let system to generate one for your new added object) "
    cout " "
    itemId = "DXGJJXJOA789ESOE"
    partId = 0
    repType = "FRN$NULL"
    Set dsDL = New DXDatastoreDL
    Set xdo = New DXBlobDL
    xdo.init dsDL
    xdo.setPartId partId
    xdo.setItemId itemId
    xdo.setRepType repType
    cout "  itemId = " & itemId
    cout "  partId = " & partId
    cout "  repType = " & repType
    cout " "
    cout "The following files will be used for add() & update(): "
    cout "(please change it to the files you have with fullpath)"
    cout " "
    fileName1 = "e:\\dlv200j\\test\\notepart.txt"
    fileName2 = "e:\\dlv200j\\test\\testupt.txt"
    cout " file for add    = " & fileName1
    cout " file for update = " & fileName2
    cout " "
    cout "Connecting to datastore of LIBSRVRP in DL ...."
    dsDL.Connect "LIBSRVRP", "FRNADMIN", "PASSWORD", ""
    On Error GoTo Errors
    cout "===Datastore connected==="
    Disconnect.Enabled = True
    Connect.Enabled = False
    Add.Enabled = True
    Retrieve.Enabled = True
    Delete.Enabled = True
    Update.Enabled = True
    
    Exit Sub
Errors:
      cout "Errors:" & str(Err.Number) & Err.Description
    
End Sub

Private Sub Disconnect_Click()
  cout "disconnect from DL server"
  dsDL.Disconnect
  On Error GoTo Errors
  cout "===datastore disconnected==="
  Connect.Enabled = True
  Disconnect.Enabled = False
  Add.Enabled = False
  Retrieve.Enabled = False
  Delete.Enabled = False
  Update.Enabled = False
  Exit Sub

Errors:
    cout "Errors:" & str(Err.Number) & Err.Description
End Sub

Private Sub Add_Click()

    Results.Text = ""

    cout "itemId=" & xdo.getItemId
    cout "partId=" & xdo.getPartId
    cout "repType=" & xdo.getRepType
    cout "fileName for add=" & fileName1

    xdo.setContentClass DX_DL_CC_ASCII
    xdo.setContentFromClientFile fileName1
    On Error GoTo Errors
    
    cout "about to add()..."
    xdo.Add
    On Error GoTo Errors
    cout "add successfully..."
    cout "after added partId = " & xdo.getPartId
    Exit Sub

Errors:
    cout "Errors:" & str(Err.Number) & Err.Description
    
End Sub

Private Sub Retrieve_Click()

    Results.Text = ""
    cout "itemId=" & xdo.getItemId
    cout "partId=" & xdo.getPartId
    cout "repType=" & xdo.getRepType


    Dim mflag As Boolean
    mflag = xdo.isCategoryOf(DX_DL_MEDIA_OBJECT)
    cout "isCategoryOf media obj = " & mflag
    If (mflag) Then
      cout "about to get mediaStream extension obj..."
      Dim aVS2 As Variant
      Set aVS2 = xdo.getExtension("DXMediaStreamInfoDL")
      On Error GoTo Errors
      cout " aVS2.getMediaCopyRate=" & aVS2.getMediaCopyRate
      cout " aVS2.getMediaInvalidCommands=" & aVS2.getMediaInvalidCommands
      cout " aVS2.getMediaDurSeconds=" & aVS2.getMediaDurSeconds
      cout " aVS2.getMediaDurFrames=" & aVS2.getMediaDurFrames
      cout " aVS2.getMediaFrameRate=" & aVS2.getMediaFrameRate
      cout " aVS2.getMediaBitRate=" & aVS2.getMediaBitRate
      cout " aVS2.getMediaNumberOfUsers=" & aVS2.getMediaNumberOfUsers
      cout " aVS2.getMediaAssetGroup=" & aVS2.getMediaAssetGroup
      cout " aVS2.getMediaType=" & aVS2.getMediaType
      cout " aVS2.getMediaResolution=" & aVS2.getMediaResolution
      cout " aVS2.getMediaStandard=" & aVS2.getMediaStandard
      cout " aVS2.getMediaFormat=" & aVS2.getMediaFormat
      cout " aVS2.getMediaState=" & aVS2.getMediaState
      cout "xdo.retrieveObjectState(media) =" & xdo.retrieveObjectState(DX_DL_MEDIA_OBJECT)
      On Error GoTo Errors
    End If


    cout "===before retrieve==="
    cout " length=" & xdo.length
    cout " getSize=" & xdo.getSize
    cout " updatedTimestamp=" & xdo.getUpdatedTimestamp
    cout " createdTimestamp=" & xdo.getCreatedTimestamp
    cout " mimeType=" & xdo.getMimeType
    cout "===about to retrieve(filedl.txt)==="
    xdo.Retrieve ("filedl.txtX")
    On Error GoTo Errors
    cout "  retrieve successfully"

    cout "===about to open()==="
    cout " ++Note: do open for ASCII file only++ "
    'If xdo.getContentClass() = DX_DL_CC_IBMVSS Then
    '  xdo.setInstanceOpenHandler "iscoview ", True
    'Else
    '  xdo.setInstanceOpenHandler "notepad ", True
    'End If
    'xdo.open

    If xdo.getContentClass() = DX_DL_CC_ASCII Then
       xdo.setInstanceOpenHandler "notepad ", True
       xdo.open
    End If
   
    Exit Sub

Errors:
    cout "Errors:" & str(Err.Number) & Err.Description

End Sub

Private Sub Delete_Click()

    Results.Text = ""
    'pid = xdo.getPidObject
    cout "itemId=" & xdo.getItemId
    cout "partId=" & xdo.getPartId

    Dim mflag As Boolean
    mflag = xdo.isCategoryOf(DX_DL_MEDIA_OBJECT)
    cout "isCategoryOf media obj = " & mflag
    If (mflag) Then
     cout "setting delete Option for media object ..."
     xdo.setOption DX_DL_OPT_DELETE_OPTION, DX_DL_DELETE_NO_DROPITEM_MEDIA_AVAIL
     Dim ln As Variant
     xdo.getOption DX_DL_OPT_DELETE_OPTION, ln
     cout "getOption deleteOpt=" & ln
    End If
    cout "===about to call delete==="
    xdo.del
    cout "  delete successfully"
    cout "===after  delete==="
    mflag = xdo.isCategoryOf(DX_DL_MEDIA_OBJECT)
    cout "  isCategoryOf media obj = " & mflag

    Exit Sub

Errors:
    cout "Errors:" & str(Err.Number) & Err.Description

End Sub

Private Sub Update_Click()

    Results.Text = ""

    cout "itemId=" & xdo.getItemId
    cout "partId=" & xdo.getPartId
    cout "fileName for update=" & fileName2
    
    xdo.setContentFromClientFile fileName2
    On Error GoTo Errors
    
    cout "about to update()..."
    xdo.Update
    On Error GoTo Errors
    cout "update successfully..."
    Exit Sub

Errors:
    cout "Errors:" & str(Err.Number) & Err.Description

End Sub
