' @copyright(disclaimer) 
' Licensed Materials - Property of IBM
' IBM  Enterprise Information Portal for Multiplatforms V8.1  (program number 5724-B43)
' (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.
' 
' US Government Users Restricted Rights
' Use, duplication or disclosure restricted by GSA ADP Schedule
' Contract with IBM Corp.
' 
' DISCLAIMER OF WARRANTIES :
' 
' Permission is granted to copy and modify this Sample code, and to
' distribute modified versions provided that both the copyright
' notice,- and this permission notice and warranty disclaimer appear in all copies and 
' modified versions. 
' 
' THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. 
' IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, 
' IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE IMPLIED 
' WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT WILL 
' IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT OF THE USE OF OR 
' INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE, OR COMBINATION OF THE 
' SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS LICENSORS AND 
' SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR FOR DIRECT, INDIRECT, 
' SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF 
' THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS HAVE BEEN ADVISED 
' OF THE POSSIBILITY OF SUCH DAMAGES.
'
' @endCopyright
VERSION 5.00
Begin VB.Form ProcessDoc
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Form2"
   ClientHeight    =   5328
   ClientLeft      =   48
   ClientTop       =   336
   ClientWidth     =   7704
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5328
   ScaleWidth      =   7704
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox DocText
      Height          =   5292
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   0
      Width           =   7692
   End
End
Attribute VB_Name = "ProcessDoc"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Public Sub DisplayDDO(ddo As DXDDOOD, Convert As Integer)

  Dim ItemType As Integer, count As Integer, i As Integer
  Dim pid As DXPidOD
  Dim strPidString As String
  Dim dataName As String
  Dim data As Variant
  Dim dataObj As Object
  Dim aVar As Variant
  aVar = ddo.getPropertyByName(DX_OD_PROPERTY_ITEM_TYPE)
  ItemType = aVar
  Set pid = ddo.getPidObject
  strPidString = pid.pidString
  Select Case ItemType
    Case DX_OD_DOCUMENT
      count = ddo.dataCount
      For i = 1 To count
        dataName = ddo.getDataName(i)
        If dataName = DX_OD_DKPARTS Then
         If Not (ddo.IsNull(i)) Then
          Set dataObj = ddo.GetData(i)
          ProcessParts dataObj, Convert
         End If
        End If
      Next                         ' end for i = 1 to count
  End Select

End Sub

Public Sub ProcessParts(parts As DXPartsOD, Convert As Integer)

  Dim pidXDO As DXPidXDOOD
  Dim dataObjCursor As DXSequentialIteratorOD
  Set dataObjCursor = parts.createIterator
  Dim j As Integer
  j = 0
  Dim dkObj As Object
  Dim dkXDO As DXBlobOD
  Dim ItemType As Long
  Dim MimeType As String
  Dim a As Variant
  Dim opt As Long, val As Long

  Do While dataObjCursor.more
    j = j + 1
    Set dkObj = dataObjCursor.Next
    If TypeOf dkObj Is DXBlobOD Then
      'Do something with the blob
      Set dkXDO = dkObj
      Set pidXDO = dkObj.getPidObject()
      ItemType = pidXDO.getType()
      MimeType = dkXDO.getMimeType()
      If Convert = 1 then
        ' Do the EBCDIC->ASCII conversion
        opt = DX_OD_OPT_XDO_TEXT_CONVERSION
        val = DX_OD_TEXT_ASCII
        a = val
        dkXDO.setOption opt, a
      End If
      dkXDO.retrieve
      If ItemType = DK_OD_SEGMENT Then
        DocText.Text = DocText.Text & dkXDO.getContent
      End If
    End If
  Loop                   ' end do while dataObjCursor.more

End Sub


